#include "LRU_STACK.hpp"
#include <iostream>

#ifndef _H_CACHE_SET_COLLECTION
#define _H_CACHE_SET_COLLECTION

/** Represents a single cache set collection, i.e., the line C(i,:). */
class CACHE_SET_COLLECTION {

    private:
	/** Default constructor should not be used. */
	CACHE_SET_COLLECTION();

    protected:
	/** Number of different setIDs available. */
	unsigned int k;

	/** The LRU stack datastructure used for simulation. */
	LRU_STACK* stack;

    public:

	/** Base constructor. */
	CACHE_SET_COLLECTION( unsigned int _k );

	/** Base deconstructor. */
	~CACHE_SET_COLLECTION();

	/** Brings a memory line into cache. @return Whether or not the data was cached. */
	bool bringIntoCache( unsigned long int pointer );

	/** Clears the LRU stack of all entries. */
	void clear();

};

#endif

