
#include "DIRECT_MAPPED_CACHE.hpp"

DIRECT_MAPPED_CACHE::DIRECT_MAPPED_CACHE( unsigned long int lines ) {
	_size = lines;
	_lines = new CACHE_LINE[ lines ];
	_line_size = _size / _lines; //safe; _size % _lines != 0 is caught by the CACHE class
}

DIRECT_MAPPED_CACHE::~DIRECT_MAPPED_CACHE() {
	delete [] _lines;
}

CACHE_LINE &DIRECT_MAPPED_CACHE::getLine( void* pointer ) {
	return _lines[ ( ( (unsigned long int) pointer ) / _line_size ) % _size ];
}

