
#include "CACHE_LINE.hpp"

#ifndef _H_CS_DIRECT_MAPPED_CACHE
#define _H_CS_DIRECT_MAPPED_CACHE

/** Direct Mapped cache using simple modulo as mapping function. */
class DIRECT_MAPPED_CACHE {
   protected:
    /** Number of cache lines available. */
	CACHE_LINE* _lines;
   
    /** Total cache size. */
	unsigned long int _size;
	
	/** Total cache line size. Equals _size / _lines */
	unsigned long int _line_size;

   public:
	/** Base constructor. */
	DIRECT_MAPPED_CACHE( unsigned long int lines );
   
    /** Base deconstructor. */
	~DIRECT_MAPPED_CACHE();
	
	/** Gets the cache line belonging to a given pointer.*/
	CACHE_LINE &getLine( void* pointer );
};

#endif
