
#include "LRU_STACK.hpp"

LRU_STACK::LRU_STACK() {}

LRU_STACK::LRU_STACK( unsigned long int _k ) {
	k = _k;
	data = new unsigned long int [ k ];
	start_index = k;
}

LRU_STACK::~LRU_STACK() {
	delete [] data;
}

bool LRU_STACK::exists( unsigned long int &toCheck ) {
	for( unsigned long int i=start_index; i<k; i++ )
		if ( data[ i ] == toCheck )
			return true;
	return false;
}

bool LRU_STACK::remove( unsigned long int &toRemove ) {
	for( unsigned long int i=start_index; i<k; i++ )
		if ( data[ i ] == toRemove ) {
			while ( i > start_index ) {
				data[ i ] = data [ i - 1 ];
				i--;
			}
			start_index++;
			return true;
		}
	std::cerr << "Warning: to be removed element not found!" << std::endl;
	return false;
}

void LRU_STACK::push( unsigned long int &toPush ) {
	if ( start_index == 0 ) {
		unsigned long int i = k-1;
		while ( i > 0 ) {
			data[ i ] = data[ i - 1 ];
			i--;
		}
		data[ 0 ] = toPush;
	} else {
		start_index--;
		data[ start_index ] = toPush;
	}
}

void LRU_STACK::clear() {
	start_index = k;
}

