
#include <iostream>

#ifndef _H_LRU_STACK
#define _H_LRU_STACK

/** A stack-like structure which always has the least recently used item at the bottom, and the most recently used at the top. */
class LRU_STACK {
    private:

	/** Do not use default constructor. */
	LRU_STACK();

    protected:
	
	/** Internal array used for datastructure (TODO: swap with singly linked list). */
	unsigned long int * data;

	/** Start of stack in array. */
	unsigned long int start_index;	

	/** Length of _data array. */
	unsigned long int k;

    public:

	/** Base constructor. */
	LRU_STACK( unsigned long int _k );

	/** Base deconstructor. */
	~LRU_STACK();

	/** Check if supplied value is already stored. */
	bool exists( unsigned long int &toCheck );

	/** Remove an element from the stack (prints a warning if not found). */
	bool remove( unsigned long int &toRemove );

	/** Puts an element on top of the stack. */
	void push( unsigned long int &toPush );

	/** Clear all entries. */
	void clear();

};

#endif

