import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

class onlyPublic {

	public static void main(String[] args) {
		if( args.length < 2 ) {
			System.out.println( "Usage: onlyPublic <from> <to>" );
			System.out.println( "This will read in target input c++ file, strip all private and protected references, and writes the result to target output file. This program assumes the final scope delimiter (private,protected,public) encountered during a sequential read, always is 'public'." );
			System.exit( 1 );
		}

		try {
			BufferedReader in = new BufferedReader(new FileReader( args[0] ));
			BufferedWriter out= new BufferedWriter(new FileWriter( args[1] ));
			boolean censor = false;
			String str;
			while ((str = in.readLine()) != null) {
				String temp = str.trim();
				if ( temp.equalsIgnoreCase( "private:" ) || temp.equalsIgnoreCase( "protected:" ) )
					censor=true;
				else if ( temp.equalsIgnoreCase( "public:" ) )
					censor=false;
				if ( !censor ) {
					out.write( str );
					out.newLine();
				}
			}
			in.close();
			out.close();
		} catch (Exception e) {
			System.err.println( "An error occured." );
			System.exit( 0 );
		}
	}
}

